#include "System.h"
#include <sys/time.h>

Mutex System::s_monitorLock;

struct TimeGetter
{
	timeval constructionTime;
	
	TimeGetter()
	{
		gettimeofday(&constructionTime, NULL);
	}
};
static TimeGetter s_startTime;
	
float System::GetTimeInSeconds()
{
	Mutex::ScopedLock lock(s_monitorLock);

	struct timeval now;
	gettimeofday(&now, NULL);

	return ((now.tv_sec-s_startTime.constructionTime.tv_sec)+(float)(now.tv_usec-s_startTime.constructionTime.tv_usec)/1000000.0f);
}
