#include "XWindowMouseInput.h"

#include <X11/Xlib.h>

XWindowMouseInput::XWindowMouseInput()
: m_gotFirstMotion(false)
{
}

void XWindowMouseInput::PostOSButtonEvent(unsigned int button, bool pressed)
{
	bool buttonFound = true;

	ButtonEvent butEv;
	butEv.pressed = pressed;

	switch(button)
	{
		case Button1: butEv.button = 0; break;
		case Button2: butEv.button = 1; break;
		case Button3: butEv.button = 2; break;
		default: buttonFound = false; break;
	}
	
	if(buttonFound)
	{
		PostButtonEvent(butEv);
	}
}

void XWindowMouseInput::PostOSMouseMoveEvent(int x, int y)
{
	if(m_gotFirstMotion)
	{
		MoveEvent moveEv;

		moveEv.dx = x - m_lastX;
		moveEv.dy = y - m_lastY;

		PostMoveEvent(moveEv);
	}

	m_gotFirstMotion = true;
	m_lastX = x;
	m_lastY = y;
}

