#ifndef THREADPRIMITIVESPLAT_H_
#define THREADPRIMITIVESPLAT_H_

#include "Utils.h"

#include <boost/function.hpp>

#include <windows.h>

struct ThreadPlat
{
	HANDLE m_thread;
	DWORD m_threadId;
	boost::function<void ()> m_func;

	static DWORD WINAPI StartWinThreadFunc(LPVOID param);

	ThreadPlat(const boost::function<void ()>& func);
};

struct SemaphorePlat
{
	HANDLE m_sem;
};

struct MutexPlat
{
	HANDLE m_sem;
	bool m_locked;
};

struct ConditionPlat
{
	HANDLE m_condLock;
	HANDLE m_waitSem;

	int m_waitingThreads;
};


#endif
