#ifndef WIN32WINDOWMOUSEINPUT_H_
#define WIN32WINDOWMOUSEINPUT_H_

#include "MouseInput.h"
#include <windows.h>

#define DIRECTINPUT_VERSION 0x0800
#include <dinput.h>

class Win32WindowMouseInput : public MouseInput
{
	LPDIRECTINPUT8 m_di;
	LPDIRECTINPUTDEVICE8 m_diMouse;

	HANDLE m_mouseEvent;

	void Run();

	Mutex m_monitorLock;
	Condition m_setupDoneCond;
	Thread* m_thread;
	
	HWND m_hwnd;

	bool m_quitting;

	const static int NUM_BUTTONS = 3;
	bool m_buttonStates[NUM_BUTTONS];

public:
	Win32WindowMouseInput(HWND hwnd);
	~Win32WindowMouseInput();

	void AttemptReaquire();
};

#endif
