#ifndef LOCKPOINTER_H_
#define LOCKPOINTER_H_

#include "ThreadUtils.h"
#include "Utils.h"

template <class T>
class LockPointer
{
	MutEx& m_mutex;
	T* m_obj;

public:
	LockPointer(MutEx& theMutex, T* obj)
		: m_mutex(theMutex)
		, m_obj(obj)
	{
		ASSERT(obj != 0);

		m_mutex.Lock();
	};

	~LockPointer()
	{
		m_mutex.Unlock();
	}

	T* operator->() const
	{
		return m_obj;
	}
};

#endif
