#ifndef ANALYZERS_H_
#define ANALYZERS_H_

struct ListNull {};

// A template list
template <class CAR, class CDR=ListNull>
struct TemplateList
{
	CAR head;
	CDR rest;

	TemplateList()
	{};

	TemplateList(const CAR& car, const CDR& cdr)
		: head(car)
		, rest(cdr)
	{};
};

template <class A1>
TemplateList<A1> MakeTemplateList(const A1& a1)
{
	return TemplateList<A1>(a1, ListNull());
}
template <class A1, class A2>
TemplateList<A1, TemplateList<A2> > MakeTemplateList(const A1& a1, const A2& a2)
{
	return TemplateList<A1, TemplateList<A2> >(a1, MakeTemplateList(a2));
}
template <class A1, class A2, class A3>
TemplateList<A1, TemplateList<A2, TemplateList<A3> > > MakeTemplateList(const A1& a1, const A2& a2, const A3& a3)
{
	return TemplateList<A1, TemplateList<A2, TemplateList<A3> > >(a1, MakeTemplateList(a2, a3));
}

#endif
