#ifndef TUPLE_H_
#define TUPLE_H_

template <class T, int DIM>
class Tuple
{
	T m_elems[DIM];

public:
	
	const T& operator[](int index) const {ASSERT(index >= 0); ASSERT(index < DIM); return m_elems[index];}
	T& operator[](int index) {ASSERT(index >= 0); ASSERT(index < DIM); return m_elems[index];}

	template<class OT>
	Tuple<T, DIM> operator*(const OT& rs)
	{
		Tuple<T, DIM> ret;
		for(int i=0; i<DIM; ++i) ret[i] = m_elems[i] * rs;
		return ret;
	}
	template<class OT>
	Tuple<T, DIM> operator/(const OT& rs)
	{
		Tuple<T, DIM> ret;
		for(int i=0; i<DIM; ++i) ret[i] = m_elems[i] / rs;
		return ret;
	}
};

template<class T>
Tuple<T, 2> MakeTuple(const T& a0, const T& a1)
{
	Tuple<T, 2> ret;
	ret[0] = a0;
	ret[1] = a1;
	return ret;
}
template<class T>
Tuple<T, 3> MakeTuple(const T& a0, const T& a1, const T& a2)
{
	Tuple<T, 3> ret;
	ret[0] = a0;
	ret[1] = a1;
	ret[2] = a2;
	return ret;
}
template<class T>
Tuple<T, 4> MakeTuple(const T& a0, const T& a1, const T& a2, const T& a3)
{
	Tuple<T, 4> ret;
	ret[0] = a0;
	ret[1] = a1;
	ret[2] = a2;
	ret[3] = a3;
	return ret;
}
template<class T>
Tuple<T, 5> MakeTuple(const T& a0, const T& a1, const T& a2, const T& a3, const T& a4)
{
	Tuple<T, 5> ret;
	ret[0] = a0;
	ret[1] = a1;
	ret[2] = a2;
	ret[3] = a3;
	ret[4] = a4;
	return ret;
}

#endif
