#include <FIFOAllocator.h>
#include <iostream>

int main(int argc, char** args)
{
	{
		FIFOAllocator testAllocator(sizeof(int) * 10);

		int* first = static_cast<int*>(testAllocator.Allocate(sizeof(int)*4)); // uses 5
		int* second = static_cast<int*>(testAllocator.Allocate(sizeof(int)*4)); // uses 5, we're full now
		
		ASSERT(second - first == 5);
		testAllocator.Free(first);
		first = static_cast<int*>(testAllocator.Allocate(sizeof(int)*4));

		ASSERT(second - first == 5);
		testAllocator.Free(second);

		second = static_cast<int*>(testAllocator.Allocate(sizeof(int))); // uses 2
		ASSERT(second - first == 5);

		testAllocator.Free(first);
		first = static_cast<int*>(testAllocator.Allocate(sizeof(int))); // uses 2

		ASSERT(first - second == 2);
		testAllocator.Free(second);

		testAllocator.Free(first);
	}

	std::cout << "Passed test 1" << std::endl;

	{
		FIFOAllocator testAllocator(sizeof(int)*81);

		void* testPtr = testAllocator.Allocate(sizeof(int)*40);
		testAllocator.Free(testPtr);
		testPtr = testAllocator.Allocate(sizeof(int)*40);
		testAllocator.Free(testPtr);
		testPtr = testAllocator.Allocate(sizeof(int)*40);
		testAllocator.Free(testPtr);
	}

	std::cout << "Passed test 2" << std::endl;

	{
		FIFOAllocator testAllocator(sizeof(int)*37);

		for(int j=0; j<2000; ++j)
		{
			int* testPtrs[10];
	
			for(int i=0; i<10; ++i)
			{
				testPtrs[i] = static_cast<int*>(testAllocator.Allocate(sizeof(int)));
				*testPtrs[i] = i;
			}
	
			for(int i=0; i<10; ++i)
			{
				ASSERT(*testPtrs[i] == i);
				testAllocator.Free(testPtrs[i]);
			}
		}
	}

	std::cout << "Passed test 3" << std::endl;

	{
		FIFOAllocator testAllocator(80);

		for(int j=0; j<1000; ++j)
		{
			void* testPtrs[10];
			for(int i=0; i<10; ++i)
			{
				testPtrs[i] = testAllocator.Allocate(4);
			}
			for(int i=0; i<10; ++i)
			{
				testAllocator.Free(testPtrs[i]);
			}
		}
	}

	std::cout << "Passed test 4" << std::endl;
	return 0;
}
