#ifndef SCENEEXPLORER_H_
#define SCENEEXPLORER_H_

#include <GraphicsContext.h>
#include <KeyboardInput.h>
#include <MouseInput.h>

#include <boost/function.hpp>

class WorldDefinition;
class Camera;

class SceneExplorer
{
	bool m_forward;
	bool m_back;
	bool m_left;
	bool m_right;

	bool m_toggleFullscreen;

	bool m_quitFlag;

	int m_mouseX;
	int m_mouseY;

	Thread* m_sceneThread;

	void ProcessKeyboardInput(const KeyboardInput::KeyEvent& key);
	void ProcessMouseMove(const MouseInput::MoveEvent& moveEvent);

	void ProcessInput(float deltaT, Camera& cam, float curScale);

	void Run();

	const WorldDefinition& m_worldDef;

	GraphicsContext& m_graphicsContext;
	KeyboardInput& m_keyboardInput;
	MouseInput& m_mouseInput;

public:
	SceneExplorer(const WorldDefinition& worldDef, GraphicsContext& graphicsContext, KeyboardInput& keyboardInput, MouseInput& mouseInput);
	~SceneExplorer();
};

#endif
