#include "Camera.h"

#include <R3Utils.h>


Camera::Camera(const Matrix<4,4>& camMat)
{
	m_camRotation = camMat;
	// Normalize the columns of the rotation matrix
	for(int i=0; i<3; ++i)
	{
		m_camRotation.SetColumn(i, m_camRotation.GetColumn(i).Normalized());
	}
	m_camRotation.SetColumn(3, Vector<4>(0,0,0,1));
	m_camPos = camMat.GetColumn(3);
}

Matrix<4,4> Camera::GetTransMatrix() const
{
	Matrix<4,4> transMat(MakeIdentityMatrix());
	transMat.SetColumn(3, m_camPos);
	
	return transMat*m_camRotation;
}

Matrix<4,4> Camera::GetModelView() const
{
	return GetTransMatrix().Inverse();
}

void Camera::AddPitch(float angle)
{
	m_camRotation = m_camRotation*MakeRotationMatrix(-angle, 'x');
}

void Camera::AddYaw(float angle)
{
	m_camRotation = m_camRotation*MakeRotationMatrix(-angle, 'y');
}

